image: docker:stable
services:
  - docker:dind

variables:
  DOCKER_HOST: tcp://docker:2375
  DOCKER_DRIVER: overlay2
  ZFS_VERSION: 0.8.0

stages:
  - image
  - compile
  - test
  - publish

publish:
  tags:
   - gitlab-org
  stage: publish
  script: ls -lsaR
  artifacts:
    expire_in: 1 week
    paths:
      - deb/
      - build_*
      - test_*

build image:
  tags:
   - gitlab-org
  stage: image
  script:
    - apk add make
    - make -j2 docker
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker push $CI_REGISTRY_IMAGE

# Runs the build for the kernel in the extended job name for all supported
# ubuntu versions
.runBuild:
  tags:
   - gitlab-org
  stage: compile
  variables:
    KERNEL_VERSION: $CI_JOB_NAME
  script:
    - apk add make
    - make -j2 build
  artifacts:
    paths:
     - deb/
     - build_*
    expire_in: 1 day

# Runs the test-suite in a VM for the extended job of <distro>:<kernel>
# distro has to be supported and kernel has to be built in the pipeline
.runTest:
  tags:
   - gitlab-org
  stage: test
  image: google/cloud-sdk:alpine
  before_script:
    - "export KERNEL_VERSION=$(echo $CI_JOB_NAME | cut -d: -f2)"
    - "export UBUNTU_DIST=$(echo $CI_JOB_NAME | cut -d: -f1)"
  script:
    - test -n "${KERNEL_VERSION}"
    - test -n "${UBUNTU_DIST}"
    - bash test.sh
  artifacts:
    paths:
     - test_*
    expire_in: 1 day

# 4.15.x
4.15.0-1032-gcp:
  extends: .runBuild
bionic:4.15.0-1032-gcp:
  extends: .runTest
xenial:4.15.0-1032-gcp:
  extends: .runTest
4.15.0-1033-gcp:
  extends: .runBuild
bionic:4.15.0-1033-gcp:
  extends: .runTest
xenial:4.15.0-1033-gcp:
  extends: .runTest

# 4.18.x
# test bionic only, as xenial does not provide 4.18
4.18.0-1011-gcp:
  extends: .runBuild
bionic:4.18.0-1011-gcp:
  extends: .runTest
